import 'package:flutter/material.dart';
import 'package:bird/signal_wave.dart';
import 'package:bird_flutter/bird_flutter.dart' as self;
import 'package:flutter_hooks/flutter_hooks.dart';

extension WaveTypeHookExtension<T> on WaveType<T> {
  // ignore: deprecated_member_use_from_same_package
  T get hook => self.$(() => this);
  // ignore: deprecated_member_use_from_same_package
  T hookKeyed(List<Object> keys) => self.$(() => this, keys: keys);
}

@Deprecated("Please use .hook instead")
T $<T>(WaveType<T> Function() wave, {List<Object> keys}) =>
    Hook.use(_WaveHook(keys, wave));

class _WaveHook<T> extends Hook<T> {
  final WaveType<T> Function() signal;

  const _WaveHook(List<Object> keys, this.signal) : super(keys: keys);

  @override
  _WaveHookState<T> createState() => _WaveHookState<T>();
}

class _WaveHookState<T> extends HookState<T, _WaveHook<T>> {
  Disposable disposable;

  WaveType<T> wave;

  @override
  T build(BuildContext context) => wave.value;

  @override
  void initHook() {
    super.initHook();
    wave = hook.signal();
    disposable?.cancel();
    disposable = wave.subscribe((T data) => setState(() {}));
  }

  @override
  void dispose() {
    disposable.cancel();
    super.dispose();
  }
}
